import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

/**
 * The AnimatedActor class serves as a superclass for other, more specific
 * Actor classes. It provides a mechanism to give actors an animated image.
 * 
 * ...more here.. image names
 * 
 * @author mik, reacomodado por Maria Susana Acuna Rodriguez
 * @version 1.0
 */
public class AnimatedActor extends Mover
{
    private GreenfootImage[] images;
    private int currentImage = 0;
    private int ni;
/**
 * el constructor recibe como parametros la base del nombre de la imagen, seguido por la terminacion del archivo, y el entero representa el numero de imagenes a cargar.
 * almacena la imagen en un arreglo de GreenfootImage del tamano del parametro entero.
 * @param basename es el nombre de la imagen a cargar
 * @suffix es la terminacion de la imagen por ejemplo .png
 * @noOfImages es el numero de imagenes por el cual se compone el gift
 */    
    public AnimatedActor(String basename, String suffix, int noOfImages)
    {
        images = new GreenfootImage[noOfImages];
        ni=noOfImages;
        for(int i=0; i < noOfImages; i++) {
            images[i] = new GreenfootImage(basename + i + suffix);
        }
        setImage(images[currentImage]);
 }
 /**
  * en Espejo es un metodo creado para poder voltear la imagen, como si se reflejara en un espejo, es necesaria cuando la ciguena se mueve hacia el lado
  * izquierdo.
  * no tiene parametros.
  */
     public void enEspejo()
    {
        
        
        for(int i=0;i<ni;i++)
        {
            images[i].mirrorHorizontally();
        }
        setImage(images[currentImage]);
    
        
    }
    /**
     * cambiaImagen es creada para que el usuario pueda observar como la ciguena toma el color del bebe con el cual se intersecto.
     * @param basename es el nombre  de la imagen a cargar
 * @suffix es la terminacion de la imagen por ejemplo .png
 * @noOfImages es el numero de imagenes por el cual se compone el gift 
     */
    public void cambiaImagen(String basename, String suffix, int noOfImages)
    {
        GreenfootImage[] aux;
        aux=new GreenfootImage[noOfImages];
        for(int i=0;i< noOfImages;i++)
        {
            aux[i]=new GreenfootImage(basename + i + suffix);
            images[i]=aux[i];    
        }
        setImage(images[currentImage]);
   }
            
    public void act() 
    {
        currentImage = (currentImage + 1) % images.length;
        setImage(images[currentImage]);
    }
}