import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Font;
/**
 * Casitas es el mundo en donde se desarrolla la historia de nuestra simptica Ciguena, capaz de esquivar todos los obstaculos con tal de cumplir su trabajo.
 * 
 * author Maria Susana Acuna Rodriguez.
 * @version May 31, 2010
 */
public class Mundo  extends World
{
/**
 * Mundo es subclase del World, en donde insteractuan todos los actores para dar vida a
 * este escenario.
 * Sus variables de instancia representan lo mas importante considerado para este escenario
 * @param int level=1 inicializa y marca el nivel actual en el que se encuentra el jugador
 * @private Ciguena cig es un Objeto de la clase Ciguena, la cual es nuestro principal actor en el mundo.
 * 
 */
    private int nivel=1;
    private Ciguena cig;
    private int puntos=100;   
    protected Score pun;
    
    /**
     * El constructor de nuestro mundo manda llamar al constructor de su clase superior
     * para indicarle que se inicializa con 150 x 113 celdas a 5 pixeles.
     * Tambien manda llamar a inicio, un metodo de el mismo.
     * 
     */
     public Mundo()
    {    
        super(150, 113, 5); 
        inicio();
    }
    public void act()
    {
    }
    /** inicio es el metodo que da arranque al juego, en donde cambia el fondo, y agrega objetos de tipo boton
     * para que el usuario pueda elegir que es lo que quiere hacer.
     * no recibe parametros.
     */
  
    public void inicio()
    {
        puntos=100;
        nivel=1;
        removeObjects(getObjects(Menu.class));
        removeObjects(getObjects(Atras.class));
        setBackground("portada4.jpg");
        Jugar boton1 = new Jugar(this);
        addObject(boton1,12,105);
        Ayuda boton2= new Ayuda(this);
        addObject(boton2,45,105);
        Credito boton3=new Credito(this);
        addObject(boton3,78,105);
    }
 
 /**
     * juego, es el metodo en el cual se inicializa el fondo del escenario y remueve los objetos botones para poder mandar llamar
     * al metodo que inicia el primer nivel del juego.
     * no recibe parametros.
     */
    public void juego()
    {
        setBackground("cielo.jpg");
        removeObjects(getObjects(Menu.class));
        removeObjects(getObjects(null));
        removeObjects(getObjects(null));
        setBackground("cielo.jpg");
        primerNivel();
        
    }
    /**
     * primer nivel es el metido que incorpora a todos los objetos que van a interactuar  en el mundo, les manda sus parametros correspondientes 
     * a cada Objeto para que sea inicializado mediante su constructor. Tambien elimina todos los objetos que puedan encontrarse en el mundo antes
     * de agregar a los verdaderos actores.
     */

    public void primerNivel()
    {
        Resultado rest = new Resultado(nivel,puntos);   
       
       addObject(rest, 80, 50);
       Greenfoot.delay(30);
       removeObject(rest);
       removeObjects(getObjects(null));
       removeObjects(getObjects(Menu.class));
       setBackground("cielo.jpg");
       formaNubesNivel1();
       addObject(new Cuervo(),0,65);  
       cig=new Ciguena(3,nivel,puntos);
       addObject(cig,30,30);
    }
    
   /**
     * segundoNivel es el metodo en el cual es mandado llamar por el actor principal indicandole que ya termino el primer nivel y le manda como parametro los puntos acumulados por el
     * actor principal.
     * @param p   p es el parametro de los puntos acumulados por el actor principal.en este caso la ciguena
     */
 
    public void segundoNivel(int p)
    {
      nivel++;
      Resultado rest = new Resultado(nivel,puntos);   
       
       addObject(rest, 80, 50);
       Greenfoot.delay(30);
       removeObject(rest);
       removeObjects(getObjects(null));
       removeObjects(getObjects(Menu.class));
       setBackground("cielo.jpg");
       formaNubesNivel1();
       addObject(new Cuervo(),150,30);
       addObject(new Cuervo(),0,65); 
       cig=new Ciguena(3,nivel,p);
       addObject(cig,30,30);    
    }
    
    /** tercerNivel es el metodo en el cual es mandado llamar por el actor principal indicandole que ya termino el primer nivel y le manda como parametro los puntos acumulados por el
     * actor principal.
     * @param p   p es el parametro de los puntos acumulados por el actor principal.en este caso la ciguena
     */


     public void tercerNivel(int p)
     {
      nivel++;
      Resultado rest = new Resultado(nivel,puntos);   
       puntos=p;
       
       addObject(rest, 80, 50);
       Greenfoot.delay(30);
       removeObject(rest);
       remueveObjetos();
        
       formaNubesNivel1();
       addObject(new Cuervo(),150,30);
       addObject(new Cuervo(),0,50);
        
       addObject(new Cuervo(),150,68);
        
       cig=new Ciguena(3,nivel,p);
       addObject(cig,30,30);
 }
 /**
  * ayuda es el metodo en el cual si es presionado el boton HELP despliega en pantalla una imagen con el movimiento del actor principal explicandolo brevemente.
  */
    public void ayuda()
    {
        removeObjects(getObjects(null));
        setBackground("ayudaboton.jpg");
        Jugar bt= new Jugar(this);
        addObject(bt,120,90);
    }
     /**
  * ayuda es el metodo en el cual si es presionado el boton CREDITS despliega en pantalla una imagen con la informacion basica del autor.
  */
    public void creditos()
    {
        removeObjects(getObjects(null));
        setBackground("creditos.png");
        Atras bt= new Atras(this);
        addObject(bt,130,50);
    }
    /**
     * metodo en el cual se forman todas las nubes en el Mundo, no recibe parametros.
     */
    public void formaNubesNivel1()
    {
        Nube n1=new Nube();
        Nube n3=new Nube();
        Nube n4=new Nube();
        Nube n5=new Nube();
        addObject(n1,7,20);
        addObject(n3,60,50);
        addObject(n5,100,20);
        addObject(n4,130,50);
}
/**
 * gameOver despliega en pantalla una imagen en donde te avisa que haz perdido, tambien aqui remueve todos los objetos que se encuentran en el mundo
 * en ese instante
 */
public void gameOver()
{
remueveObjetos();
setBackground("youlose.png");
Menu m=new Menu(this);
addObject(m,30,100);
}
/**
 * winner despliega en pantalla una imagen en donde te avisa que haz GANADO, tambien aqui remueve todos los objetos que se encuentran en el mundo
 * en ese instante
 * @param p  p son los puntos acumulados por el actor mientras el usuario lo hacia actuar, son los puntos que mostrara al usuario cuando el juego ha terminado.
 */
public void winner(int p)
{
remueveObjetos();
setBackground("maggiesimpson.png");
Menu m=new Menu(this);
addObject(m,30,100);
nivel++;
puntos=p;
Resultado rest = new Resultado(nivel,puntos);   
addObject(rest, 80, 50);
Greenfoot.delay(30);
removeObject(rest);
}

/** remueveObjetos es el metido en donde se quitan del escenario todos los actores
 * 
 */
public void remueveObjetos()
{
removeObjects(getObjects(Ciguena.class));
removeObjects(getObjects(Vida.class));
removeObjects(getObjects(Nube.class));
removeObjects(getObjects(Bebe.class));
removeObjects(getObjects(Bebe2.class));
removeObjects(getObjects(Score.class));
removeObjects(getObjects(Corazon.class));
removeObjects(getObjects(Cuervo.class));
removeObjects(getObjects(Casa.class));
removeObjects(getObjects(Menu.class));
}   
/**
 * remueveBebes es un metodo especial que solo es llamado por su actor principal.
 */ 
public void remueveBebes()
{
removeObjects(getObjects(Bebe.class));
removeObjects(getObjects(Bebe2.class));
}    
}
